diff --git a/sys/mips/include/vmparam.h b/sys/mips/include/vmparam.h
index edc8f37294aa..45fc8eebdf41 100644
--- a/sys/mips/include/vmparam.h
+++ b/sys/mips/include/vmparam.h
@@ -83,15 +83,64 @@
 
 #ifdef __mips_n64
 #define	VM_MAXUSER_ADDRESS	(VM_MINUSER_ADDRESS + (NPDEPG * NBSEG))
-#define	VM_MIN_KERNEL_ADDRESS	((vm_offset_t)0xc000000000000000)
-#define	VM_MAX_KERNEL_ADDRESS	(VM_MIN_KERNEL_ADDRESS + (NPDEPG * NBSEG))
-#else
-#define	VM_MAXUSER_ADDRESS	((vm_offset_t)0x80000000)
-#define	VM_MIN_KERNEL_ADDRESS	((vm_offset_t)0xC0000000)
-#define	VM_MAX_KERNEL_ADDRESS	((vm_offset_t)0xFFFFC000)
-#endif
+#ifdef CPU_CHERI
 
-#define	KERNBASE		((vm_offset_t)(intptr_t)(int32_t)0x80000000)
+/*
+ * Lay out some bitmaps for us, ranging from VM_CAPREVOKE_BM_BASE
+ * to VM_CAPREVOKE_BM_TOP:
+ *
+ * TOP:
+ * 	- shared page for per-process information (_INFO_PAGE)
+ * 	- one bit per otype (BM_OTYPE)
+ * 	- one bit per page, checked for VMMAP-bearing caps (BM_MEM_MAP)
+ * 	- one bit per cap, checked for non-VMMAP-bearing caps (BM_MEM_NOMAP)
+ * BASE:
+ *
+ * The granularities of these bitmaps are specified in the _GSZ_ constants.
+ * For the present settings, a *byte* of these bitmaps spans....
+ * 	- 8 otypes
+ * 	- 8 pages (32KiB of memory)
+ * 	- 128 bytes of memory (on CC and CHERI-128; 256 bytes on CHERI-256)
+ * Requests to access the shadow space must, therefore, be at least that
+ * aligned!
+ *
+ */
+
+#define VM_CAPREVOKE_GSZ_OTYPE		((vm_offset_t)1)
+#define VM_CAPREVOKE_GSZ_MEM_MAP	((vm_offset_t)PAGE_SIZE)
+#define VM_CAPREVOKE_GSZ_MEM_NOMAP	((vm_offset_t)sizeof (void * __capability))
+
+#define VM_CAPREVOKE_BSZ_MEM_NOMAP	(NPDEPG * NBSEG  / VM_CAPREVOKE_GSZ_MEM_NOMAP / 8)
+#define VM_CAPREVOKE_BSZ_MEM_MAP	(NPDEPG * NBSEG  / VM_CAPREVOKE_GSZ_MEM_MAP   / 8)
+#define VM_CAPREVOKE_BSZ_OTYPE		((1 << CHERI_OTYPE_BITS) / VM_CAPREVOKE_GSZ_OTYPE     / 8)
+/* XXX TODO SetCID revocation? */
+
+#define VM_CAPREVOKE_BM_TOP	VM_MAXUSER_ADDRESS
+#define VM_CAPREVOKE_BM_BASE	( VM_CAPREVOKE_BM_TOP \
+					- VM_CAPREVOKE_BSZ_MEM_NOMAP \
+					- VM_CAPREVOKE_BSZ_MEM_MAP \
+					- VM_CAPREVOKE_BSZ_OTYPE \
+					- PAGE_SIZE )
+#define VM_CAPREVOKE_BM_MEM_NOMAP	VM_CAPREVOKE_BM_BASE
+#define VM_CAPREVOKE_BM_MEM_MAP		( VM_CAPREVOKE_BM_MEM_NOMAP  \
+					+ VM_CAPREVOKE_BSZ_MEM_NOMAP )
+#define VM_CAPREVOKE_BM_OTYPE		( VM_CAPREVOKE_BM_MEM_MAP  \
+					+ VM_CAPREVOKE_BSZ_MEM_MAP )
+#define VM_CAPREVOKE_INFO_PAGE		( VM_CAPREVOKE_BM_OTYPE  \
+					+ VM_CAPREVOKE_BSZ_OTYPE )
+
+#define	SHAREDPAGE		(VM_CAPREVOKE_BM_BASE - PAGE_SIZE)
+/*
+ * To ensure that the stack base address that is sufficiently aligned, we
+ * jump down quite a bit.
+ *
+ * XXX The idea of "the" USRSTACK top/base really should go away; as
+ * rlimits are changed, our alignment requirements change as well, so
+ * there's no one right answer.
+ */
+#define	USRSTACK		(SHAREDPAGE & ~0xFFFFFFF)
+
+#else
 /*
  * USRSTACK needs to start a little below 0x8000000 because the R8000
  * and some QED CPUs perform some virtual address checks before the
@@ -103,6 +152,19 @@
  * a bounded capability we must round down by 16 pages to get to 0x7ffbff0000.
  */
 #define	USRSTACK		(SHAREDPAGE - (15 * PAGE_SIZE))
+#endif
+
+#define	VM_MIN_KERNEL_ADDRESS	((vm_offset_t)0xc000000000000000)
+#define	VM_MAX_KERNEL_ADDRESS	(VM_MIN_KERNEL_ADDRESS + (NPDEPG * NBSEG))
+#else
+#define	VM_MAXUSER_ADDRESS	((vm_offset_t)0x80000000)
+#define	VM_MIN_KERNEL_ADDRESS	((vm_offset_t)0xC0000000)
+#define	VM_MAX_KERNEL_ADDRESS	((vm_offset_t)0xFFFFC000)
+#define	SHAREDPAGE		(VM_MAXUSER_ADDRESS - PAGE_SIZE)
+#define	USRSTACK		SHAREDPAGE
+#endif
+
+#define	KERNBASE		((vm_offset_t)(intptr_t)(int32_t)0x80000000)
 #ifdef __mips_n64
 #define	FREEBSD32_SHAREDPAGE	(((vm_offset_t)0x80000000) - PAGE_SIZE)
 #define	FREEBSD32_USRSTACK	FREEBSD32_SHAREDPAGE
diff --git a/sys/mips/mips/genassym.c b/sys/mips/mips/genassym.c
index 35b2064e3ae4..658ccc83aa96 100644
--- a/sys/mips/mips/genassym.c
+++ b/sys/mips/mips/genassym.c
@@ -130,6 +130,8 @@ ASSYM(MIPS_XKSEG_START, MIPS_XKSEG_START);
 
 #ifdef	CPU_CHERI
 ASSYM(U_PCB_CHERIKFRAME, offsetof(struct pcb, pcb_cherikframe));
+ASSYM(VM_CAPREVOKE_BM_BASE, VM_CAPREVOKE_BM_BASE);
+ASSYM(VM_CAPREVOKE_BM_TOP, VM_CAPREVOKE_BM_TOP);
 #endif
 
 #ifdef	CPU_CNMIPS
diff --git a/sys/mips/mips/locore.S b/sys/mips/mips/locore.S
index a2bf2e92c722..59adbb8a835b 100644
--- a/sys/mips/mips/locore.S
+++ b/sys/mips/mips/locore.S
@@ -199,6 +199,21 @@ VECTOR(_locore, unknown)
 	PTR_LA	t0, _C_LABEL(user_sealcap)
 	csc	CHERI_REG_C27, t0, 0($ddc)
 
+#ifdef CHERI_CAPREVOKE
+	/*
+	 * And one more, this time for access to the caprev shadow space
+	 */
+	cmove		CHERI_REG_C27, CHERI_REG_C28
+	REG_LI	t0, VM_CAPREVOKE_BM_BASE
+	csetoffset	CHERI_REG_C27, CHERI_REG_C27, t0
+	REG_LI	t0, (VM_CAPREVOKE_BM_TOP - VM_CAPREVOKE_BM_BASE)
+	csetbounds	CHERI_REG_C27, CHERI_REG_C27, t0
+	REG_LI	t0, (CHERI_PERM_LOAD | CHERI_PERM_STORE)
+	candperm	CHERI_REG_C27, CHERI_REG_C27, t0
+	PTR_LA	t0, _C_LABEL(caprev_shadow_cap)
+	csc	CHERI_REG_C27, t0, 0($ddc)
+#endif
+
 	/*
 	 * Store the omnipotent capability to allow swap to be restored.
 	 */
diff --git a/sys/mips/mips/mp_machdep.c b/sys/mips/mips/mp_machdep.c
index f49dd7553d33..9d51614573a2 100644
--- a/sys/mips/mips/mp_machdep.c
+++ b/sys/mips/mips/mp_machdep.c
@@ -286,6 +286,12 @@ smp_init_secondary(u_int32_t cpuid)
 		mips_wr_hwrena(mips_rd_hwrena() | MIPS_HWRENA_UL);
 
 	/* TLB */
+#ifdef BERI_LARGE_TLB
+	/* If extended TLB entries is implemented then enable it. */
+#define	BERI_CP5_LTLB_SUPPORTED	0x1
+	if (mips_rd_config5() & BERI_CP5_LTLB_SUPPORTED)
+		mips_wr_config6(mips_rd_config6() | 0x4);
+#endif
 	mips_wr_wired(0);
 	tlb_invalidate_all();
 	mips_wr_wired(VMWIRED_ENTRIES);
diff --git a/sys/mips/mips/pm_machdep.c b/sys/mips/mips/pm_machdep.c
index 7b2a52abd953..edb8f0d9d473 100644
--- a/sys/mips/mips/pm_machdep.c
+++ b/sys/mips/mips/pm_machdep.c
@@ -81,6 +81,10 @@ __FBSDID("$FreeBSD$");
 #include <cheri/cheri.h>
 #include <cheri/cheric.h>
 #include <machine/cheri_machdep.h>
+#ifdef CHERI_CAPREVOKE
+#include <sys/caprevoke.h>
+#include <vm/vm_caprevoke.h>
+#endif
 #endif
 
 #include <ddb/ddb.h>
@@ -960,6 +964,59 @@ ptrace_clear_single_step(struct thread *td)
 	td->td_md.md_ss_addr = 0;
 	return 0;
 }
+
+#ifdef CHERI_CAPREVOKE
+
+void
+caprevoke_td_frame(struct thread *td, const struct vm_caprevoke_cookie *crc)
+{
+	CAPREVOKE_STATS_FOR(crst, crc);
+
+#define CAPREV_REG(r) \
+	do { if (cheri_gettag(r)) { \
+		CAPREVOKE_STATS_BUMP(crst, caps_found); \
+		if (vm_caprevoke_test(crc, r)) { \
+			r = cheri_revoke(r); \
+			CAPREVOKE_STATS_BUMP(crst, caps_cleared); \
+		} \
+	    }} while(0)
+
+	CAPREV_REG(td->td_frame->ddc);
+	CAPREV_REG(td->td_frame->c1);
+	CAPREV_REG(td->td_frame->c2);
+	CAPREV_REG(td->td_frame->c3);
+	CAPREV_REG(td->td_frame->c4);
+	CAPREV_REG(td->td_frame->c5);
+	CAPREV_REG(td->td_frame->c6);
+	CAPREV_REG(td->td_frame->c7);
+	CAPREV_REG(td->td_frame->c8);
+	CAPREV_REG(td->td_frame->c9);
+	CAPREV_REG(td->td_frame->c10);
+	CAPREV_REG(td->td_frame->csp);
+	CAPREV_REG(td->td_frame->c12);
+	CAPREV_REG(td->td_frame->c13);
+	CAPREV_REG(td->td_frame->c14);
+	CAPREV_REG(td->td_frame->c15);
+	CAPREV_REG(td->td_frame->c16);
+	CAPREV_REG(td->td_frame->c17);
+	CAPREV_REG(td->td_frame->c18);
+	CAPREV_REG(td->td_frame->c19);
+	CAPREV_REG(td->td_frame->c20);
+	CAPREV_REG(td->td_frame->c21);
+	CAPREV_REG(td->td_frame->c22);
+	CAPREV_REG(td->td_frame->c23);
+	CAPREV_REG(td->td_frame->c24);
+	CAPREV_REG(td->td_frame->c25);
+	CAPREV_REG(td->td_frame->idc);
+	CAPREV_REG(td->td_frame->pcc); /* This could be real exciting! */
+
+#undef CAPREV_REG
+
+	return;
+}
+
+#endif
+
 // CHERI CHANGES START
 // {
 //   "updated": 20181114,
diff --git a/sys/mips/mips/pmap.c b/sys/mips/mips/pmap.c
index 9f890b0ddf4d..04b5c8d4a14a 100644
--- a/sys/mips/mips/pmap.c
+++ b/sys/mips/mips/pmap.c
@@ -1490,6 +1490,10 @@ pmap_pv_reclaim(pmap_t locked_pmap)
 				m = PHYS_TO_VM_PAGE(TLBLO_PTE_TO_PA(oldpte));
 				if (pte_test(&oldpte, PTE_D))
 					vm_page_dirty(m);
+#ifdef PTE_SC
+				if (pte_test(&oldpte, PTE_SC) == 0)
+					vm_page_capdirty(m);
+#endif
 				if (m->md.pv_flags & PV_TABLE_REF)
 					vm_page_aflag_set(m, PGA_REFERENCED);
 				m->md.pv_flags &= ~PV_TABLE_REF;
@@ -1763,6 +1767,10 @@ pmap_remove_pte(struct pmap *pmap, pt_entry_t *ptq, vm_offset_t va,
 			    __func__, (void *)va, (uintmax_t)oldpte));
 			vm_page_dirty(m);
 		}
+#ifdef PTE_SC
+		if (pte_test(&oldpte, PTE_SC) == 0)
+			vm_page_capdirty(m);
+#endif
 		if (m->md.pv_flags & PV_TABLE_REF)
 			vm_page_aflag_set(m, PGA_REFERENCED);
 		m->md.pv_flags &= ~PV_TABLE_REF;
@@ -1942,6 +1950,10 @@ pmap_remove_all(vm_page_t m)
 			    __func__, (void *)pv->pv_va, (uintmax_t)tpte));
 			vm_page_dirty(m);
 		}
+#ifdef PTE_SC
+		if (pte_test(&tpte, PTE_SC) == 0)
+			vm_page_capdirty(m);
+#endif
 		pmap_invalidate_page(pmap, pv->pv_va);
 
 		TAILQ_REMOVE(&m->md.pv_list, pv, pv_list);
@@ -2035,6 +2047,16 @@ pmap_protect(pmap_t pmap, vm_offset_t sva, vm_offset_t eva, vm_prot_t prot)
 					va = va_next;
 				}
 			}
+#ifdef PTE_SC
+			if (pte_test(&pbits, PTE_SC) == 0) {
+				pte_set(&pbits, PTE_SC);
+				if (pte_test(&pbits, PTE_MANAGED)) {
+					pa = TLBLO_PTE_TO_PA(pbits);
+					m = PHYS_TO_VM_PAGE(pa);
+					vm_page_capdirty(m);
+				}
+			}
+#endif
 			*pte = pbits;
 		}
 		if (va != va_next)
@@ -2082,8 +2104,26 @@ pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
 #ifdef CPU_CHERI
 	if ((flags & PMAP_ENTER_NOLOADTAGS) != 0)
 		newpte |= PTE_LC;
-	if ((flags & PMAP_ENTER_NOSTORETAGS) != 0)
+	/*
+	 * If this page is unmanaged, don't try to track its capdirty status
+	 * (so determine PTE_SC entirely from NOSTORETAGS).  On the other
+	 * hand, if it's already capdirty, avoid the overhead of faulting,
+	 * since all we'd do is set the bit again (eventually, in
+	 * pmap_emulate_capdirty).
+	 *
+	 * Transfer NOSTORETAGS to PTE_CRO.
+	 *
+	 * XXX NWF: I would like, eventually, to track capdirty in the
+	 * kernel as well, but for the moment, doing this trips a panic in
+	 * pmap_emulate_capdirty because it can't find the PTE in question.
+	 * I am sure I am just holding something wrong.
+	 */
+	if ((((m->oflags & VPO_UNMANAGED) == 0)
+		&& ((m->a.flags & PGA_CAPSTORED) == 0))
+	    || ((flags & PMAP_ENTER_NOSTORETAGS) != 0))
 		newpte |= PTE_SC;
+	if ((flags & PMAP_ENTER_NOSTORETAGS) != 0)
+		newpte |= PTE_CRO;
 #endif
 	if ((m->oflags & VPO_UNMANAGED) == 0)
 		newpte |= PTE_MANAGED;
@@ -2121,6 +2161,11 @@ pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
 	KASSERT(!pte_test(&origpte, PTE_D | PTE_RO | PTE_V),
 	    ("pmap_enter: modified page not writable: va: %p, pte: %#jx",
 	    (void *)va, (uintmax_t)origpte));
+#ifdef PTE_SC
+	KASSERT(!pte_test(&origpte, PTE_CRO | PTE_V) || pte_test(&origpte, PTE_SC),
+	    ("pmap_enter: capdirty with CRO set: va: %p, pte: %#jx",
+	    (void *)va, (uintmax_t)origpte));
+#endif
 	opa = TLBLO_PTE_TO_PA(origpte);
 
 	/*
@@ -2170,6 +2215,10 @@ pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
 			om = PHYS_TO_VM_PAGE(opa);
 			if (pte_test(&origpte, PTE_D))
 				vm_page_dirty(om);
+#ifdef PTE_SC
+			if (pte_test(&origpte, PTE_SC) == 0)
+				vm_page_capdirty(m);
+#endif
 			if ((om->md.pv_flags & PV_TABLE_REF) != 0) {
 				om->md.pv_flags &= ~PV_TABLE_REF;
 				vm_page_aflag_set(om, PGA_REFERENCED);
@@ -2235,6 +2284,11 @@ pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
 				if (pte_test(&origpte, PTE_MANAGED))
 					vm_page_dirty(m);
 			}
+#ifdef PTE_SC
+			if ((pte_test(&origpte, PTE_SC) == 0)
+			    && pte_test(&origpte, PTE_MANAGED))
+				vm_page_capdirty(m);
+#endif
 			pmap_update_page(pmap, va, newpte);
 		}
 	}
@@ -2619,10 +2673,21 @@ pmap_copy_page_internal(vm_page_t src, vm_page_t dst, int flags)
 		va_src = MIPS_PHYS_TO_DIRECT(phys_src);
 		va_dst = MIPS_PHYS_TO_DIRECT(phys_dst);
 #ifdef CPU_CHERI
-		if (flags & PMAP_COPY_TAGS)
+		if (flags & PMAP_COPY_TAGS) {
 			cheri_bcopy((caddr_t)va_src, (caddr_t)va_dst,
 			    PAGE_SIZE);
-		else
+
+			/*
+			 * If we're copying tags, consider the target page
+			 * capdirty, even if tere might not be tags on the
+			 * page.  We can't accurately get the PTE's capdirty
+			 * bit, at this point, so err on the side of safety.
+			 *
+			 * XXX Can we do better?
+			 */
+	
+			vm_page_capdirty(dst);
+		} else
 #endif
 			bcopy((caddr_t)va_src, (caddr_t)va_dst, PAGE_SIZE);
 		mips_dcache_wbinv_range(va_dst, PAGE_SIZE);
@@ -2679,6 +2744,7 @@ pmap_copy_pages_internal(vm_page_t ma[], vm_offset_t a_offset, vm_page_t mb[],
 		cnt = min(cnt, PAGE_SIZE - b_pg_offset);
 		b_m = mb[b_offset >> PAGE_SHIFT];
 		b_phys = VM_PAGE_TO_PHYS(b_m);
+
 		if (MIPS_DIRECT_MAPPABLE(a_phys) &&
 		    MIPS_DIRECT_MAPPABLE(b_phys)) {
 			pmap_flush_pvcache(a_m);
@@ -2689,9 +2755,21 @@ pmap_copy_pages_internal(vm_page_t ma[], vm_offset_t a_offset, vm_page_t mb[],
 			b_cp = (char *)MIPS_PHYS_TO_DIRECT(b_phys) +
 			    b_pg_offset;
 #ifdef CPU_CHERI
-			if (flags & PMAP_COPY_TAGS)
+			if (flags & PMAP_COPY_TAGS) {
 				cheri_bcopy(a_cp, b_cp, cnt);
-			else
+
+				/*
+				 * If we're copying tags, consider the
+				 * target page capdirty, even if tere might
+				 * not be tags on the page.  We can't
+				 * accurately get the PTE's capdirty bit, at
+				 * this point, so err on the side of safety.
+				 *
+				 * XXX Can we do better?
+				 */
+
+				vm_page_capdirty(b_m);
+			} else
 #endif
 				bcopy(a_cp, b_cp, cnt);
 			mips_dcache_wbinv_range((vm_offset_t)b_cp, cnt);
@@ -2898,6 +2976,10 @@ pmap_remove_pages(pmap_t pmap)
 				 */
 				if (pte_test(&tpte, PTE_D))
 					vm_page_dirty(m);
+#ifdef PTE_SC
+				if (pte_test(&tpte, PTE_SC) == 0)
+					vm_page_capdirty(m);
+#endif
 
 				/* Mark free */
 				PV_STAT(pv_entry_frees++);
@@ -2925,7 +3007,7 @@ pmap_remove_pages(pmap_t pmap)
  * pmap_testbit tests bits in pte's
  */
 static boolean_t
-pmap_testbit(vm_page_t m, int bit)
+pmap_testbit(vm_page_t m, pt_entry_t bit)
 {
 	pv_entry_t pv;
 	pmap_t pmap;
@@ -3006,6 +3088,12 @@ pmap_remove_write(vm_page_t m)
 			pte_clear(&pbits, PTE_D);
 			vm_page_dirty(m);
 		}
+#ifdef PTE_SC
+		if (pte_test(&pbits, PTE_SC) == 0) {
+			pte_set(&pbits, PTE_SC);
+			vm_page_capdirty(m);
+		}
+#endif
 		pte_set(&pbits, PTE_RO);
 		if (pbits != *pte) {
 			*pte = pbits;
@@ -3170,6 +3258,12 @@ pmap_advise(pmap_t pmap, vm_offset_t sva, vm_offset_t eva, int advice)
 					va = va_next;
 				}
 			}
+#ifdef PTE_SC
+			if (pte_test(pte, PTE_SC) == 0) {
+				pte_set(pte, PTE_SC);
+				vm_page_capdirty(m);
+			}
+#endif
 		}
 		if (va != va_next)
 			pmap_invalidate_range(pmap, va, sva);
@@ -3311,6 +3405,10 @@ pmap_mincore(pmap_t pmap, vm_offset_t addr, vm_paddr_t *pap)
 	val = MINCORE_INCORE;
 	if (pte_test(&pte, PTE_D))
 		val |= MINCORE_MODIFIED | MINCORE_MODIFIED_OTHER;
+#ifdef PTE_SC
+	if (pte_test(&pte, PTE_SC) == 0)
+		val |= MINCORE_MAYHAVECAP;
+#endif
 	pa = TLBLO_PTE_TO_PA(pte);
 	if (pte_test(&pte, PTE_MANAGED)) {
 		/*
@@ -3547,6 +3645,175 @@ pmap_emulate_modified(pmap_t pmap, vm_offset_t va)
 	return (0);
 }
 
+#if __has_feature(capabilities)
+
+/*
+ * For every mapping of this page, collect and clear its capdirty PTE
+ * entries, promoting them to the page's PGA_CAPSTORED bit.
+ *
+ * XXX This is now only used by mincore; perhaps a more gentle approach
+ * could be taken?
+ *
+ * XREF pmap_clear_modify and pmap_is_modified
+ */
+boolean_t
+pmap_tc_capdirty(vm_page_t m)
+{
+	pv_entry_t pv;
+	boolean_t found;
+
+	/*
+	 * If the page is not exclusive busied, then PGA_WRITEABLE cannot be
+	 * concurrently set while the object is locked.  Thus, if PGA_WRITEABLE
+	 * is clear, no PTEs can have PTE_SC clear.
+	 */
+	VM_OBJECT_ASSERT_LOCKED(m->object);
+
+	found = (m->a.flags & PGA_CAPSTORED) != 0;
+
+	rw_wlock(&pvh_global_lock);
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+		pmap_t pmap;
+		pt_entry_t *pte;
+
+		pmap = PV_PMAP(pv);
+		PMAP_LOCK(pmap);
+		pte = pmap_pte(pmap, pv->pv_va);
+		if (pte_test(pte, PTE_SC) == 0) {
+			if (!found)
+				vm_page_capdirty(m);
+			found = 1;
+			pte_set(pte, PTE_SC);
+			pmap_update_page(pmap, pv->pv_va, *pte);
+		}
+		PMAP_UNLOCK(pmap);
+
+	}
+	rw_wunlock(&pvh_global_lock);
+
+	return found;
+}
+
+/*
+ * Atomically push all the in-PTE, MD capdirty bits up to the MI layer.
+ *
+ * While this is a fairly long-running operation under the current pmap
+ * lock, it's going to be called only from single-threaded context, so there
+ * should be minimal contention (perhaps from the page daemon or updates to
+ * shared mappings) as no other cores are going to have this pmap active.
+ *
+ * XREF pmap_remove_pages
+ */
+
+void
+pmap_sync_capdirty(pmap_t pmap)
+{
+	struct pv_chunk *pc, *npc;
+
+	PMAP_LOCK(pmap);
+
+	/*
+	 * While we expect that no other cores have us active right now,
+	 * because we're thread_single'd, other TLBs may still have cached
+	 * entries with PTE_SC clear!  We'd best get those out of the way.
+	 *
+	 * Doing this before clearing the bits means that even if we're
+	 * wrong about being single-threaded, those other cores will park
+	 * behind us when they go to update their TLBs.
+	 *
+	 * XXX Is it worth only invalidating the capdirty ones?
+	 */
+	tlb_invalidate_all_user(pmap);
+
+	TAILQ_FOREACH_SAFE(pc, &pmap->pm_pvchunk, pc_list, npc) {
+		int field;
+
+		for (field = 0; field < _NPCM; field++) {
+			u_long inuse;
+
+			inuse = ~pc->pc_map[field] & pc_freemask[field];
+			while (inuse != 0) {
+				pd_entry_t *pde;
+				pt_entry_t *pte, tpte;
+				pv_entry_t pv;
+				u_long bitmask;
+				int bit, idx;
+
+				bit = ffsl(inuse) - 1;
+				bitmask = 1UL << bit;
+				idx = field * sizeof(inuse) * NBBY + bit;
+				pv = &pc->pc_pventry[idx];
+				inuse &= ~bitmask;
+
+				pde = pmap_pde(pmap, pv->pv_va);
+				KASSERT(pde != NULL && *pde != 0,
+				    ("pmap_sync_capdirty: pde"));
+				pte = pmap_pde_to_pte(pde, pv->pv_va);
+				if (!pte_test(pte, PTE_V))
+					panic("pmap_sync_capdirty: bad pte");
+				tpte = *pte;
+
+				if (pte_test(&tpte, PTE_MANAGED) == 0)
+					continue;
+
+				if (pte_test(&tpte, PTE_SC) == 0) {
+					vm_page_t m;
+
+					m = PHYS_TO_VM_PAGE(
+					      TLBLO_PTE_TO_PA(tpte));
+					KASSERT(m != NULL,
+					  ("pmap_sync_capdirty: bad tpte %#jx",
+					   (uintmax_t)(tpte)));
+
+					KASSERT(pte_test(&tpte, PTE_CRO) == 0,
+					 ("cap-read-only without inhibit?"));
+
+					vm_page_capdirty(m);
+					pte_set(pte, PTE_SC);
+				}
+			}
+		}
+	}
+
+	PMAP_UNLOCK(pmap);
+}
+
+/* XREF pmap_emulate_modified */
+int
+pmap_emulate_capdirty(pmap_t pmap, vm_offset_t va)
+{
+	pt_entry_t *pte;
+
+	PMAP_LOCK(pmap);
+	pte = pmap_pte(pmap, va);
+	if (pte == NULL)
+		panic("pmap_emulate_capdirty: can't find PTE");
+#ifdef SMP
+	/* It is possible that some other CPU changed m-bit */
+	if (!pte_test(pte, PTE_V) || !pte_test(pte, PTE_SC)) {
+		tlb_update(pmap, va, *pte);
+		PMAP_UNLOCK(pmap);
+		return (0);
+	}
+#else
+	if (!pte_test(pte, PTE_V) || !pte_test(pte, PTE_SC))
+		panic("pmap_emulate_capdirty: invalid pte");
+#endif
+	if (pte_test(pte, PTE_RO) || pte_test(pte, PTE_CRO)) {
+		PMAP_UNLOCK(pmap);
+		return (1);
+	}
+
+	pte_clear(pte, PTE_SC);
+	tlb_update(pmap, va, *pte);
+	if (!pte_test(pte, PTE_MANAGED))
+		panic("pmap_emulate_capdirty: unmanaged page");
+	PMAP_UNLOCK(pmap);
+	return 0;
+}
+
+#endif
+
 /*
  *	Routine:	pmap_kextract
  *	Function:
diff --git a/sys/mips/mips/trap.c b/sys/mips/mips/trap.c
index b6ed3254cda8..bcd30e0a2cde 100644
--- a/sys/mips/mips/trap.c
+++ b/sys/mips/mips/trap.c
@@ -677,6 +677,36 @@ cpu_fetch_syscall_args(struct thread *td)
 #define __FBSDID(x)
 #include "../../kern/subr_syscall.c"
 
+#ifdef CPU_CHERI
+static inline int
+try_emulate_capdirty(struct trapframe *trapframe, pmap_t kpmap, pmap_t upmap)
+{
+	register_t cause = trapframe->capcause;
+
+	cause &= CHERI_CAPCAUSE_EXCCODE_MASK;
+	cause >>= CHERI_CAPCAUSE_EXCCODE_SHIFT;
+
+	if (cause == CHERI_EXCCODE_TLBSTORE) {
+		/*
+		 * This could just need capdirty emulation; we cannot get
+		 * here unless the TLB entry is permitted to store, just not
+		 * store capabilities.  That is, all CoW will have already
+		 * been handled for us, thank goodness.
+		 */
+
+		vm_offset_t va = trapframe->badvaddr;
+
+		if (KERNLAND(va)) {
+			if (kpmap) {
+				return pmap_emulate_capdirty(kpmap, va);
+			}
+		} else {
+			return pmap_emulate_capdirty(upmap, va);
+		}
+	}
+	return 1;
+}
+#endif
 
 /*
  * Handle an exception.
@@ -1137,6 +1167,11 @@ trap(struct trapframe *trapframe)
 		break;
 #ifdef CPU_CHERI
 	case T_C2E:
+		if(try_emulate_capdirty(trapframe, kernel_pmap,
+					&p->p_vmspace->vm_pmap) == 0) {
+			return trapframe->pc;
+		}
+
 		if (td->td_pcb->pcb_onfault != NULL) {
 			pc = trapf_pc_from_kernel_code_ptr(td->td_pcb->pcb_onfault);
 			td->td_pcb->pcb_onfault = NULL;
@@ -1156,6 +1191,15 @@ trap(struct trapframe *trapframe)
 		if (KTRPOINT(td, KTR_CEXCEPTION))
 			ktrcexception(trapframe);
 #endif
+
+		if (try_emulate_capdirty(trapframe, NULL,
+					 &p->p_vmspace->vm_pmap) == 0) {
+			if (!usermode) {
+				return (trapframe->pc);
+			}
+			goto out;
+		}
+
 		fetch_bad_instr(trapframe);
 		log_c2e_exception(msg, trapframe, type);
 		i = SIGPROT;
diff --git a/sys/mips/mips/vm_machdep.c b/sys/mips/mips/vm_machdep.c
index 18259feae769..637cd46cd286 100644
--- a/sys/mips/mips/vm_machdep.c
+++ b/sys/mips/mips/vm_machdep.c
@@ -60,6 +60,7 @@ __FBSDID("$FreeBSD$");
 #include <sys/unistd.h>
 #include <sys/vmem.h>
 
+#include <machine/_inttypes.h>
 #include <machine/abi.h>
 #include <machine/cache.h>
 #include <machine/clock.h>
@@ -87,6 +88,7 @@ __FBSDID("$FreeBSD$");
 #include <vm/uma.h>
 #include <vm/uma_int.h>
 
+#include <sys/stdatomic.h>
 #include <sys/user.h>
 #include <sys/mbuf.h>
 
